diff --git a/libpurple/account.c b/libpurple/account.c
--- a/libpurple/account.c
+++ b/libpurple/account.c
@@ -33,6 +33,7 @@
 #include "purplecredentialmanager.h"
 #include "purpleprivate.h"
 #include "purpleprotocolclient.h"
+#include "purpleprotocolserver.h"
 #include "request.h"
 #include "server.h"
 #include "signals.h"
@@ -1856,9 +1857,11 @@
 	gc = purple_account_get_connection(account);
 	protocol = purple_connection_get_protocol(gc);
 
-	if (PURPLE_PROTOCOL_IMPLEMENTS(protocol, SERVER, set_public_alias))
-		purple_protocol_server_iface_set_public_alias(protocol, gc, alias, success_cb, failure_cb);
-	else if (failure_cb) {
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		purple_protocol_server_set_public_alias(PURPLE_PROTOCOL_SERVER(protocol),
+		                                        gc, alias, success_cb,
+		                                        failure_cb);
+	} else if(failure_cb) {
 		struct public_alias_closure *closure =
 				g_new0(struct public_alias_closure, 1);
 		closure->account = g_object_ref(account);
@@ -1881,9 +1884,10 @@
 	gc = purple_account_get_connection(account);
 	protocol = purple_connection_get_protocol(gc);
 
-	if (PURPLE_PROTOCOL_IMPLEMENTS(protocol, SERVER, get_public_alias))
-		purple_protocol_server_iface_get_public_alias(protocol, gc, success_cb, failure_cb);
-	else if (failure_cb) {
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		purple_protocol_server_get_public_alias(PURPLE_PROTOCOL_SERVER(protocol),
+		                                        gc, success_cb, failure_cb);
+	} else if(failure_cb) {
 		struct public_alias_closure *closure =
 				g_new0(struct public_alias_closure, 1);
 		closure->account = g_object_ref(account);
@@ -2858,9 +2862,12 @@
 	if (gc != NULL)
 		protocol = purple_connection_get_protocol(gc);
 
-	if (protocol != NULL)
-		purple_protocol_server_iface_add_buddy(protocol, gc, buddy,
-				purple_buddy_get_group(buddy), message);
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		PurpleGroup *group = purple_buddy_get_group(buddy);
+
+		purple_protocol_server_add_buddy(PURPLE_PROTOCOL_SERVER(protocol), gc,
+		                                 buddy, group, message);
+	}
 }
 
 void
@@ -2881,16 +2888,9 @@
 			groups = g_list_append(groups, purple_buddy_get_group(buddy));
 		}
 
-		if (PURPLE_PROTOCOL_IMPLEMENTS(protocol, SERVER, add_buddies))
-			purple_protocol_server_iface_add_buddies(protocol, gc, buddies, groups, message);
-		else if (PURPLE_PROTOCOL_IMPLEMENTS(protocol, SERVER, add_buddy)) {
-			GList *curb = buddies, *curg = groups;
-
-			while ((curb != NULL) && (curg != NULL)) {
-				purple_protocol_server_iface_add_buddy(protocol, gc, curb->data, curg->data, message);
-				curb = curb->next;
-				curg = curg->next;
-			}
+		if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+			purple_protocol_server_add_buddies(PURPLE_PROTOCOL_SERVER(protocol),
+			                                   gc, buddies, groups, message);
 		}
 
 		g_list_free(groups);
@@ -2907,8 +2907,10 @@
 	if (gc != NULL)
 		protocol = purple_connection_get_protocol(gc);
 
-	if (protocol)
-		purple_protocol_server_iface_remove_buddy(protocol, gc, buddy, group);
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		purple_protocol_server_remove_buddy(PURPLE_PROTOCOL_SERVER(protocol),
+		                                    gc, buddy, group);
+	}
 }
 
 void
@@ -2920,18 +2922,9 @@
 	if (gc != NULL)
 		protocol = purple_connection_get_protocol(gc);
 
-	if (protocol) {
-		if (PURPLE_PROTOCOL_IMPLEMENTS(protocol, SERVER, remove_buddies))
-			purple_protocol_server_iface_remove_buddies(protocol, gc, buddies, groups);
-		else {
-			GList *curb = buddies;
-			GList *curg = groups;
-			while ((curb != NULL) && (curg != NULL)) {
-				purple_account_remove_buddy(account, curb->data, curg->data);
-				curb = curb->next;
-				curg = curg->next;
-			}
-		}
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		purple_protocol_server_remove_buddies(PURPLE_PROTOCOL_SERVER(protocol),
+		                                      gc, buddies, groups);
 	}
 }
 
@@ -2944,8 +2937,10 @@
 	if (gc != NULL)
 		protocol = purple_connection_get_protocol(gc);
 
-	if (protocol)
-		purple_protocol_server_iface_remove_group(protocol, gc, group);
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		purple_protocol_server_remove_group(PURPLE_PROTOCOL_SERVER(protocol),
+		                                    gc, group);
+	}
 }
 
 void
@@ -2966,8 +2961,10 @@
 	if (gc != NULL)
 		protocol = purple_connection_get_protocol(gc);
 
-	if (protocol)
-		purple_protocol_server_iface_change_passwd(protocol, gc, orig_pw, new_pw);
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		purple_protocol_server_change_passwd(PURPLE_PROTOCOL_SERVER(protocol),
+		                                     gc, orig_pw, new_pw);
+	}
 }
 
 gboolean purple_account_supports_offline_message(PurpleAccount *account, PurpleBuddy *buddy)
diff --git a/libpurple/buddyicon.c b/libpurple/buddyicon.c
--- a/libpurple/buddyicon.c
+++ b/libpurple/buddyicon.c
@@ -25,6 +25,7 @@
 #include "debug.h"
 #include "image.h"
 #include "purpleprivate.h"
+#include "purpleprotocolserver.h"
 #include "util.h"
 
 /* NOTE: Instances of this struct are allocated without zeroing the memory, so
@@ -757,8 +758,10 @@
 		gc = purple_account_get_connection(account);
 		protocol = purple_connection_get_protocol(gc);
 
-		if (protocol)
-			purple_protocol_server_iface_set_buddy_icon(protocol, gc, img);
+		if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+			purple_protocol_server_set_buddy_icon(PURPLE_PROTOCOL_SERVER(protocol),
+			                                      gc, img);
+		}
 	}
 
 	if (old_img)
diff --git a/libpurple/connection.c b/libpurple/connection.c
--- a/libpurple/connection.c
+++ b/libpurple/connection.c
@@ -33,6 +33,7 @@
 #include "prefs.h"
 #include "proxy.h"
 #include "purpleprivate.h"
+#include "purpleprotocolserver.h"
 #include "purpleprotocolfactory.h"
 #include "request.h"
 #include "server.h"
@@ -125,7 +126,8 @@
 	PurpleConnection *gc = data;
 	PurpleConnectionPrivate *priv = purple_connection_get_instance_private(gc);
 
-	purple_protocol_server_iface_keepalive(priv->protocol, gc);
+	purple_protocol_server_keepalive(PURPLE_PROTOCOL_SERVER(priv->protocol),
+	                                 gc);
 
 	return TRUE;
 }
@@ -140,7 +142,7 @@
 
 	if (on && !priv->keepalive)
 	{
-		int interval = purple_protocol_server_iface_get_keepalive_interval(priv->protocol);
+		int interval = purple_protocol_server_get_keepalive_interval(PURPLE_PROTOCOL_SERVER(priv->protocol));
 		purple_debug_info("connection", "Activating keepalive to %d seconds.", interval);
 		priv->keepalive = g_main_context_find_source_by_id(NULL, g_timeout_add_seconds(interval, send_keepalive, gc));
 	}
@@ -677,7 +679,7 @@
 		 * it seems unlikely that the implementation will change, we just do that
 		 * for now as a workaround for this API shortcoming.
 		 */
-		gint64 seconds_from_now = purple_protocol_server_iface_get_keepalive_interval(priv->protocol);
+		gint64 seconds_from_now = purple_protocol_server_get_keepalive_interval(PURPLE_PROTOCOL_SERVER(priv->protocol));
 
 		g_source_set_ready_time(
 			priv->keepalive,
@@ -1038,7 +1040,8 @@
 		priv = purple_connection_get_instance_private(gc);
 		priv->wants_to_die = TRUE;
 
-		purple_protocol_server_iface_register_user(protocol, account);
+		purple_protocol_server_register_user(PURPLE_PROTOCOL_SERVER(protocol),
+		                                     account);
 	}
 	else
 	{
@@ -1051,7 +1054,7 @@
 
 void
 _purple_connection_new_unregister(PurpleAccount *account, const char *password,
-		PurpleAccountUnregistrationCb cb, void *user_data)
+		PurpleAccountUnregistrationCb cb, gpointer user_data)
 {
 	/* Lots of copy/pasted code to avoid API changes. You might want to integrate that into the previous function when posssible. */
 	PurpleConnection *gc;
@@ -1073,7 +1076,8 @@
 	}
 
 	if (!purple_account_is_disconnected(account)) {
-		purple_protocol_server_iface_unregister_user(protocol, account, cb, user_data);
+		purple_protocol_server_unregister_user(PURPLE_PROTOCOL_SERVER(protocol),
+		                                       account, cb, user_data);
 		return;
 	}
 
@@ -1101,7 +1105,8 @@
 
 	purple_debug_info("connection", "Unregistering.  gc = %p\n", gc);
 
-	purple_protocol_server_iface_unregister_user(protocol, account, cb, user_data);
+	purple_protocol_server_unregister_user(PURPLE_PROTOCOL_SERVER(protocol),
+	                                       account, cb, user_data);
 }
 
 /**************************************************************************
diff --git a/libpurple/group.c b/libpurple/group.c
--- a/libpurple/group.c
+++ b/libpurple/group.c
@@ -24,6 +24,7 @@
 #include "group.h"
 #include "internal.h" /* TODO: we need to kill this */
 #include "purpleprivate.h"
+#include "purpleprotocolserver.h"
 
 typedef struct _PurpleGroupPrivate      PurpleGroupPrivate;
 
@@ -212,7 +213,9 @@
 			}
 
 			if(PURPLE_PROTOCOL_IMPLEMENTS(protocol, SERVER, rename_group)) {
-				purple_protocol_server_iface_rename_group(protocol, gc, old_name, source, buddies);
+				purple_protocol_server_rename_group(PURPLE_PROTOCOL_SERVER(protocol),
+				                                    gc, old_name, source,
+				                                    buddies);
 			} else {
 				GList *cur, *groups = NULL;
 
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -65,6 +65,7 @@
 	'purpleprotocolim.c',
 	'purpleprotocolmedia.c',
 	'purpleprotocolprivacy.c',
+	'purpleprotocolserver.c',
 	'purpleuiinfo.c',
 	'purplewhiteboard.c',
 	'purplewhiteboarduiops.c',
@@ -154,6 +155,7 @@
 	'purpleprotocolim.h',
 	'purpleprotocolmedia.h',
 	'purpleprotocolprivacy.h',
+	'purpleprotocolserver.h',
 	'purpleuiinfo.h',
 	'purplewhiteboard.h',
 	'purplewhiteboardops.h',
diff --git a/libpurple/protocol.h b/libpurple/protocol.h
--- a/libpurple/protocol.h
+++ b/libpurple/protocol.h
@@ -138,144 +138,6 @@
 	void (*_purple_reserved4)(void);
 };
 
-#define PURPLE_TYPE_PROTOCOL_SERVER (purple_protocol_server_iface_get_type())
-
-typedef struct _PurpleProtocolServerInterface PurpleProtocolServerInterface;
-
-/**
- * PurpleProtocolServerInterface:
- * @register_user:   New user registration
- * @unregister_user: Remove the user from the server. The account can either be
- *                   connected or disconnected. After the removal is finished,
- *                   the connection will stay open and has to be closed!
- * @get_info:        Should arrange for purple_notify_userinfo() to be called
- *                   with @who's user info.
- * @add_buddy:       Add a buddy to a group on the server.
- *                   <sbr/>This protocol function may be called in situations in
- *                   which the buddy is already in the specified group. If the
- *                   protocol supports authorization and the user is not already
- *                   authorized to see the status of @buddy, @add_buddy should
- *                   request authorization.
- *                   <sbr/>If authorization is required, then use the supplied
- *                   invite message.
- * @keepalive:       If implemented, this will be called regularly for this
- *                   protocol's active connections. You'd want to do this if you
- *                   need to repeatedly send some kind of keepalive packet to
- *                   the server to avoid being disconnected. ("Regularly" is
- *                   defined to be 30 unless @get_keepalive_interval is
- *                   implemented to override it).
- *                   <filename>libpurple/connection.c</filename>.)
- * @get_keepalive_interval: If implemented, this will override the default
- *                          keepalive interval.
- * @alias_buddy:     Save/store buddy's alias on server list/roster
- * @group_buddy:     Change a buddy's group on a server list/roster
- * @rename_group:    Rename a group on a server list/roster
- * @set_buddy_icon:  Set the buddy icon for the given connection to @img. The
- *                   protocol does <emphasis>NOT</emphasis> own a reference to
- *                   @img; if it needs one, it must #g_object_ref(@img)
- *                   itself.
- * @send_raw:        For use in plugins that may understand the underlying
- *                   protocol
- * @set_public_alias: Set the user's "friendly name" (or alias or nickname or
- *                    whatever term you want to call it) on the server. The
- *                    protocol should call @success_cb or @failure_cb
- *                    <emphasis>asynchronously</emphasis> (if it knows
- *                    immediately that the set will fail, call one of the
- *                    callbacks from an idle/0-second timeout) depending on if
- *                    the nickname is set successfully. See
- *                    purple_account_set_public_alias().
- *                    <sbr/>@gc:    The connection for which to set an alias
- *                    <sbr/>@alias: The new server-side alias/nickname for this
- *                                  account, or %NULL to unset the
- *                                  alias/nickname (or return it to a
- *                                  protocol-specific "default").
- *                    <sbr/>@success_cb: Callback to be called if the public
- *                                       alias is set
- *                    <sbr/>@failure_cb: Callback to be called if setting the
- *                                       public alias fails
- * @get_public_alias: Retrieve the user's "friendly name" as set on the server.
- *                    The protocol should call @success_cb or @failure_cb
- *                    <emphasis>asynchronously</emphasis> (even if it knows
- *                    immediately that the get will fail, call one of the
- *                    callbacks from an idle/0-second timeout) depending on if
- *                    the nickname is retrieved. See
- *                    purple_account_get_public_alias().
- *                    <sbr/>@gc:         The connection for which to retireve
- *                                       the alias
- *                    <sbr/>@success_cb: Callback to be called with the
- *                                       retrieved alias
- *                    <sbr/>@failure_cb: Callback to be called if the protocol
- *                                       is unable to retrieve the alias
- *
- * The protocol server interface.
- *
- * This interface provides a gateway between purple and the protocol's server.
- */
-struct _PurpleProtocolServerInterface
-{
-	/*< private >*/
-	GTypeInterface parent_iface;
-
-	/*< public >*/
-	void (*register_user)(PurpleAccount *account);
-
-	void (*unregister_user)(PurpleAccount *account, PurpleAccountUnregistrationCb cb,
-							void *user_data);
-
-	void (*set_info)(PurpleConnection *connection, const char *info);
-
-	void (*get_info)(PurpleConnection *connection, const char *who);
-
-	void (*set_status)(PurpleAccount *account, PurpleStatus *status);
-
-	void (*set_idle)(PurpleConnection *connection, int idletime);
-
-	void (*change_passwd)(PurpleConnection *connection, const char *old_pass,
-						  const char *new_pass);
-
-	void (*add_buddy)(PurpleConnection *pc, PurpleBuddy *buddy,
-					  PurpleGroup *group, const char *message);
-
-	void (*add_buddies)(PurpleConnection *pc, GList *buddies, GList *groups,
-						const char *message);
-
-	void (*remove_buddy)(PurpleConnection *connection, PurpleBuddy *buddy,
-						 PurpleGroup *group);
-
-	void (*remove_buddies)(PurpleConnection *connection, GList *buddies, GList *groups);
-
-	void (*keepalive)(PurpleConnection *connection);
-
-	int (*get_keepalive_interval)(void);
-
-	void (*alias_buddy)(PurpleConnection *connection, const char *who,
-						const char *alias);
-
-	void (*group_buddy)(PurpleConnection *connection, const char *who,
-					const char *old_group, const char *new_group);
-
-	void (*rename_group)(PurpleConnection *connection, const char *old_name,
-					 PurpleGroup *group, GList *moved_buddies);
-
-	void (*set_buddy_icon)(PurpleConnection *connection, PurpleImage *img);
-
-	void (*remove_group)(PurpleConnection *gc, PurpleGroup *group);
-
-	int (*send_raw)(PurpleConnection *gc, const char *buf, int len);
-
-	void (*set_public_alias)(PurpleConnection *gc, const char *alias,
-	                         PurpleSetPublicAliasSuccessCallback success_cb,
-	                         PurpleSetPublicAliasFailureCallback failure_cb);
-
-	void (*get_public_alias)(PurpleConnection *gc,
-	                         PurpleGetPublicAliasSuccessCallback success_cb,
-	                         PurpleGetPublicAliasFailureCallback failure_cb);
-};
-
-#define PURPLE_IS_PROTOCOL_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), PURPLE_TYPE_PROTOCOL_SERVER))
-#define PURPLE_PROTOCOL_SERVER_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE((obj), PURPLE_TYPE_PROTOCOL_SERVER, \
-                                               PurpleProtocolServerInterface))
-
 /**
  * PURPLE_PROTOCOL_IMPLEMENTS:
  * @protocol: The protocol in which to check
@@ -388,104 +250,6 @@
 const char *purple_protocol_class_list_icon(PurpleProtocol *protocol,
 		PurpleAccount *account, PurpleBuddy *buddy);
 
-/**************************************************************************/
-/* Protocol Server Interface API                                          */
-/**************************************************************************/
-
-/**
- * purple_protocol_server_iface_get_type:
- *
- * Returns: The #GType for the protocol server interface.
- */
-GType purple_protocol_server_iface_get_type(void);
-
-void purple_protocol_server_iface_register_user(PurpleProtocol *protocol,
-		PurpleAccount *account);
-
-/**
- * purple_protocol_server_iface_unregister_user:
- * @cb: (scope call):
- */
-void purple_protocol_server_iface_unregister_user(PurpleProtocol *protocol,
-		PurpleAccount *account, PurpleAccountUnregistrationCb cb, void *user_data);
-
-void purple_protocol_server_iface_set_info(PurpleProtocol *protocol, PurpleConnection *connection,
-		const char *info);
-
-void purple_protocol_server_iface_get_info(PurpleProtocol *protocol, PurpleConnection *connection,
-		const char *who);
-
-void purple_protocol_server_iface_set_status(PurpleProtocol *protocol,
-		PurpleAccount *account, PurpleStatus *status);
-
-void purple_protocol_server_iface_set_idle(PurpleProtocol *protocol, PurpleConnection *connection,
-		int idletime);
-
-void purple_protocol_server_iface_change_passwd(PurpleProtocol *protocol,
-		PurpleConnection *connection, const char *old_pass, const char *new_pass);
-
-void purple_protocol_server_iface_add_buddy(PurpleProtocol *protocol,
-		PurpleConnection *pc, PurpleBuddy *buddy, PurpleGroup *group,
-		const char *message);
-
-void purple_protocol_server_iface_add_buddies(PurpleProtocol *protocol,
-		PurpleConnection *pc, GList *buddies, GList *groups,
-		const char *message);
-
-void purple_protocol_server_iface_remove_buddy(PurpleProtocol *protocol,
-		PurpleConnection *connection, PurpleBuddy *buddy, PurpleGroup *group);
-
-void purple_protocol_server_iface_remove_buddies(PurpleProtocol *protocol,
-		PurpleConnection *connection, GList *buddies, GList *groups);
-
-void purple_protocol_server_iface_keepalive(PurpleProtocol *protocol,
-		PurpleConnection *connection);
-
-int purple_protocol_server_iface_get_keepalive_interval(PurpleProtocol *protocol);
-
-void purple_protocol_server_iface_alias_buddy(PurpleProtocol *protocol,
-		PurpleConnection *connection, const char *who, const char *alias);
-
-void purple_protocol_server_iface_group_buddy(PurpleProtocol *protocol,
-		PurpleConnection *connection, const char *who, const char *old_group,
-		const char *new_group);
-
-void purple_protocol_server_iface_rename_group(PurpleProtocol *protocol,
-		PurpleConnection *connection, const char *old_name, PurpleGroup *group,
-		GList *moved_buddies);
-
-void purple_protocol_server_iface_set_buddy_icon(PurpleProtocol *protocol,
-		PurpleConnection *connection, PurpleImage *img);
-
-void purple_protocol_server_iface_remove_group(PurpleProtocol *protocol,
-		PurpleConnection *gc, PurpleGroup *group);
-
-int purple_protocol_server_iface_send_raw(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *buf, int len);
-
-/**
- * purple_protocol_server_iface_set_public_alias:
- * @success_cb: (scope call):
- * @failure_cb: (scope call):
- */
-void purple_protocol_server_iface_set_public_alias(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *alias,
-		PurpleSetPublicAliasSuccessCallback success_cb,
-		PurpleSetPublicAliasFailureCallback failure_cb);
-
-/**
- * purple_protocol_server_iface_get_public_alias:
- * @success_cb: (scope call):
- * @failure_cb: (scope call):
- */
-void purple_protocol_server_iface_get_public_alias(PurpleProtocol *protocol,
-		PurpleConnection *gc, PurpleGetPublicAliasSuccessCallback success_cb,
-		PurpleGetPublicAliasFailureCallback failure_cb);
-
-/**************************************************************************/
-/* Protocol Chat Interface API                                            */
-/**************************************************************************/
-
 G_END_DECLS
 
 #endif /* PURPLE_PROTOCOL_H */
diff --git a/libpurple/protocol.c b/libpurple/protocol.c
--- a/libpurple/protocol.c
+++ b/libpurple/protocol.c
@@ -209,196 +209,3 @@
 
 #undef DEFINE_PROTOCOL_FUNC_WITH_RETURN
 #undef DEFINE_PROTOCOL_FUNC
-
-/**************************************************************************
- * Protocol Server Interface API
- **************************************************************************/
-#define DEFINE_PROTOCOL_FUNC(protocol,funcname,...) \
-	PurpleProtocolServerInterface *server_iface = \
-		PURPLE_PROTOCOL_SERVER_GET_IFACE(protocol); \
-	if (server_iface && server_iface->funcname) \
-		server_iface->funcname(__VA_ARGS__);
-
-#define DEFINE_PROTOCOL_FUNC_WITH_RETURN(protocol,defaultreturn,funcname,...) \
-	PurpleProtocolServerInterface *server_iface = \
-		PURPLE_PROTOCOL_SERVER_GET_IFACE(protocol); \
-	if (server_iface && server_iface->funcname) \
-		return server_iface->funcname(__VA_ARGS__); \
-	else \
-		return defaultreturn;
-
-GType
-purple_protocol_server_iface_get_type(void)
-{
-	static GType type = 0;
-
-	if (G_UNLIKELY(type == 0)) {
-		static const GTypeInfo info = {
-			.class_size = sizeof(PurpleProtocolServerInterface),
-		};
-
-		type = g_type_register_static(G_TYPE_INTERFACE,
-				"PurpleProtocolServerInterface", &info, 0);
-	}
-	return type;
-}
-
-void
-purple_protocol_server_iface_register_user(PurpleProtocol *protocol,
-		PurpleAccount *account)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, register_user, account);
-}
-
-void
-purple_protocol_server_iface_unregister_user(PurpleProtocol *protocol,
-		PurpleAccount *account, PurpleAccountUnregistrationCb cb,
-		void *user_data)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, unregister_user, account, cb, user_data);
-}
-
-void
-purple_protocol_server_iface_set_info(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *info)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, set_info, gc, info);
-}
-
-void
-purple_protocol_server_iface_get_info(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *who)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, get_info, gc, who);
-}
-
-void
-purple_protocol_server_iface_set_status(PurpleProtocol *protocol,
-		PurpleAccount *account, PurpleStatus *status)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, set_status, account, status);
-}
-
-void
-purple_protocol_server_iface_set_idle(PurpleProtocol *protocol,
-		PurpleConnection *gc, int idletime)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, set_idle, gc, idletime);
-}
-
-void
-purple_protocol_server_iface_change_passwd(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *old_pass, const char *new_pass)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, change_passwd, gc, old_pass, new_pass);
-}
-
-void
-purple_protocol_server_iface_add_buddy(PurpleProtocol *protocol,
-		PurpleConnection *gc, PurpleBuddy *buddy, PurpleGroup *group,
-		const char *message)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, add_buddy, gc, buddy, group, message);
-}
-
-void
-purple_protocol_server_iface_add_buddies(PurpleProtocol *protocol,
-		PurpleConnection *gc, GList *buddies, GList *groups,
-		const char *message)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, add_buddies, gc, buddies, groups, message);
-}
-
-void
-purple_protocol_server_iface_remove_buddy(PurpleProtocol *protocol,
-		PurpleConnection *gc, PurpleBuddy *buddy, PurpleGroup *group)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, remove_buddy, gc, buddy, group);
-}
-
-void
-purple_protocol_server_iface_remove_buddies(PurpleProtocol *protocol,
-		PurpleConnection *gc, GList *buddies, GList *groups)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, remove_buddies, gc, buddies, groups);
-}
-
-void
-purple_protocol_server_iface_keepalive(PurpleProtocol *protocol,
-		PurpleConnection *gc)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, keepalive, gc);
-}
-
-int
-purple_protocol_server_iface_get_keepalive_interval(PurpleProtocol *protocol)
-{
-	DEFINE_PROTOCOL_FUNC_WITH_RETURN(protocol, 30, get_keepalive_interval);
-}
-
-void
-purple_protocol_server_iface_alias_buddy(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *who, const char *alias)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, alias_buddy, gc, who, alias);
-}
-
-void
-purple_protocol_server_iface_group_buddy(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *who, const char *old_group,
-		const char *new_group)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, group_buddy, gc, who, old_group, new_group);
-}
-
-void
-purple_protocol_server_iface_rename_group(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *old_name, PurpleGroup *group,
-		GList *moved_buddies)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, rename_group, gc, old_name, group,
-			moved_buddies);
-}
-
-void
-purple_protocol_server_iface_set_buddy_icon(PurpleProtocol *protocol,
-		PurpleConnection *gc, PurpleImage *img)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, set_buddy_icon, gc, img);
-}
-
-void
-purple_protocol_server_iface_remove_group(PurpleProtocol *protocol,
-		PurpleConnection *gc, PurpleGroup *group)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, remove_group, gc, group);
-}
-
-int
-purple_protocol_server_iface_send_raw(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *buf, int len)
-{
-	DEFINE_PROTOCOL_FUNC_WITH_RETURN(protocol, 0, send_raw, gc, buf, len);
-}
-
-void
-purple_protocol_server_iface_set_public_alias(PurpleProtocol *protocol,
-		PurpleConnection *gc, const char *alias,
-		PurpleSetPublicAliasSuccessCallback success_cb,
-		PurpleSetPublicAliasFailureCallback failure_cb)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, set_public_alias, gc, alias, success_cb,
-			failure_cb);
-}
-
-void
-purple_protocol_server_iface_get_public_alias(PurpleProtocol *protocol,
-		PurpleConnection *gc, PurpleGetPublicAliasSuccessCallback success_cb,
-		PurpleGetPublicAliasFailureCallback failure_cb)
-{
-	DEFINE_PROTOCOL_FUNC(protocol, get_public_alias, gc, success_cb,
-			failure_cb);
-}
-
-#undef DEFINE_PROTOCOL_FUNC_WITH_RETURN
-#undef DEFINE_PROTOCOL_FUNC
diff --git a/libpurple/protocols.c b/libpurple/protocols.c
--- a/libpurple/protocols.c
+++ b/libpurple/protocols.c
@@ -33,6 +33,7 @@
 #include "purplecredentialmanager.h"
 #include "purpleprotocolattention.h"
 #include "purpleprotocolmedia.h"
+#include "purpleprotocolserver.h"
 #include "request.h"
 #include "util.h"
 
@@ -311,8 +312,10 @@
 	if (protocol == NULL)
 		return;
 
-	if (!purple_account_is_disconnected(account))
-		purple_protocol_server_iface_set_status(protocol, account, new_status);
+	if(!purple_account_is_disconnected(account)) {
+		purple_protocol_server_set_status(PURPLE_PROTOCOL_SERVER(protocol),
+		                                  account, new_status);
+	}
 }
 
 void
diff --git a/libpurple/protocols/bonjour/bonjour.c b/libpurple/protocols/bonjour/bonjour.c
--- a/libpurple/protocols/bonjour/bonjour.c
+++ b/libpurple/protocols/bonjour/bonjour.c
@@ -216,7 +216,8 @@
 }
 
 static void
-bonjour_set_status(PurpleAccount *account, PurpleStatus *status)
+bonjour_set_status(PurpleProtocolServer *protocol_server,
+                   PurpleAccount *account, PurpleStatus *status)
 {
 	PurpleConnection *gc;
 	BonjourData *bd;
@@ -258,7 +259,10 @@
  * if there is no add_buddy callback.
  */
 static void
-bonjour_fake_add_buddy(PurpleConnection *pc, PurpleBuddy *buddy, PurpleGroup *group, const char *message) {
+bonjour_fake_add_buddy(PurpleProtocolServer *protocol_server,
+                       PurpleConnection *pc, PurpleBuddy *buddy,
+                       PurpleGroup *group, const gchar *message)
+{
 	purple_debug_error("bonjour", "Buddy '%s' manually added; removing.  "
 				      "Bonjour buddies must be discovered and not manually added.\n",
 			   purple_buddy_get_name(buddy));
@@ -270,7 +274,11 @@
 }
 
 
-static void bonjour_remove_buddy(PurpleConnection *pc, PurpleBuddy *buddy, PurpleGroup *group) {
+static void
+bonjour_remove_buddy(PurpleProtocolServer *protocol_server,
+                     PurpleConnection *pc, PurpleBuddy *buddy,
+                     PurpleGroup *group)
+{
 	BonjourBuddy *bb = purple_buddy_get_protocol_data(buddy);
 	if (bb) {
 		bonjour_buddy_delete(bb);
@@ -329,7 +337,8 @@
 }
 
 static void
-bonjour_set_buddy_icon(PurpleConnection *conn, PurpleImage *img)
+bonjour_set_buddy_icon(PurpleProtocolServer *protocol_server,
+                       PurpleConnection *conn, PurpleImage *img)
 {
 	BonjourData *bd = purple_connection_get_protocol_data(conn);
 	bonjour_dns_sd_update_buddy_icon(bd->dns_sd_data);
@@ -439,18 +448,22 @@
 }
 
 static void
-bonjour_group_buddy(PurpleConnection *connection, const char *who, const char *old_group, const char *new_group)
+bonjour_group_buddy(PurpleProtocolServer *protocol_server,
+                    PurpleConnection *connection, const gchar *who,
+                    const gchar *old_group, const gchar *new_group)
 {
 	PurpleBuddy *buddy = purple_blist_find_buddy(purple_connection_get_account(connection), who);
 
 	bonjour_do_group_change(buddy, new_group);
-
 }
 
 static void
-bonjour_rename_group(PurpleConnection *connection, const char *old_name, PurpleGroup *group, GList *moved_buddies)
+bonjour_rename_group(PurpleProtocolServer *protocol_server,
+                     PurpleConnection *connection,
+                     const gchar *old_name, PurpleGroup *group,
+                     GList *moved_buddies)
 {
-	const char *new_group;
+	const gchar *new_group;
 
 	new_group = purple_group_get_name(group);
 
diff --git a/libpurple/protocols/facebook/facebook.c b/libpurple/protocols/facebook/facebook.c
--- a/libpurple/protocols/facebook/facebook.c
+++ b/libpurple/protocols/facebook/facebook.c
@@ -1167,7 +1167,8 @@
 }
 
 static void
-fb_server_set_status(PurpleAccount *acct, PurpleStatus *status)
+fb_server_set_status(PurpleProtocolServer *protocol_server,
+                     PurpleAccount *acct, PurpleStatus *status)
 {
 	FbApi *api;
 	FbData *fata;
@@ -1584,7 +1585,7 @@
 }
 
 static void
-facebook_protocol_server_iface_init(PurpleProtocolServerInterface *iface)
+facebook_protocol_server_init(PurpleProtocolServerInterface *iface)
 {
 	iface->set_status = fb_server_set_status;
 }
@@ -1621,7 +1622,7 @@
         G_IMPLEMENT_INTERFACE_DYNAMIC(PURPLE_TYPE_PROTOCOL_CLIENT,
                                       facebook_protocol_client_iface_init)
         G_IMPLEMENT_INTERFACE_DYNAMIC(PURPLE_TYPE_PROTOCOL_SERVER,
-                                      facebook_protocol_server_iface_init)
+                                      facebook_protocol_server_init)
         G_IMPLEMENT_INTERFACE_DYNAMIC(PURPLE_TYPE_PROTOCOL_IM,
                                       facebook_protocol_im_iface_init)
         G_IMPLEMENT_INTERFACE_DYNAMIC(PURPLE_TYPE_PROTOCOL_CHAT,
